#include <M5Stack.h>

// SDカードの中の以下で指定したフォルダ配下を読み込みます
String sdroot = "/m5jpg/m5jpg";
char **nameList; //ファイル名を記憶しておくリスト変数
int numList = 0; //リスト内に含まれるファイル数
int num = 0;

void setup() {
  M5.begin();
  Serial.println("初期化完了");

  // SDカードをオープンします
  File root = SD.open(sdroot);
  String listTemp = "";
  //ファイルが見つからなくなるまで繰り返します
  while (true) {
    //次のファイルを取得します
    File entry = root.openNextFile();
    if (!entry) {
      break; //これ以上ファイルがない場合
    }

    if (!entry.isDirectory()) { //ディレクトリ名ではない場合
      String fileName = entry.name();
      //ファイル名から拡張子を抽出します
      String ext = fileName.substring(fileName.lastIndexOf('.'));
      //拡張子が画像（jpgまたはJPEG）の場合
      if (ext.equalsIgnoreCase(".jpg") || ext.equalsIgnoreCase(".JPEG")) {
        //ファイル名を一時変数に入れます（カンマ区切り）
        listTemp += String(fileName);
        listTemp += ",";
      }
    }
  }

  //作成した一時リストを処理して画像ファイルリストを作成します
  if (listTemp.length() > 0) { //ファイルが1つ以上ある場合
    //画像の数を数えます
    for (int i = 0; i < listTemp.length(); i++) {
      i = listTemp.indexOf(',', i); //カンマの位置を探します
      numList++;
    }

    //二次元配列を新規作成します
    nameList = new char *[numList];
    //一時リストの中にある画像ファイル名を順番に配列に保存します
    for (int i = 0; i < numList; i++) {
      //カンマの位置を探し、その位置までをファイル名とします
      int index = listTemp.indexOf(',');
      String temp = String(listTemp.substring(0, index));
      nameList[i] =
          new char[temp.length() + 1]; //配列[i]をファイル名の長さで初期化します
      temp.toCharArray(nameList[i], temp.length() + 1);
      Serial.println(nameList[i]);

      //一時リストから読み込み済みのデータを削除します
      listTemp.remove(0, index + 1);
    }
  } else {
    //ファイルが見つからなければ終了
    Serial.println("Jpgファイルが見つかりませんでした");
  }
  showjpgSD();
}

void loop() {
  //ボタンの状態を反映します。
  M5.update();
  if (M5.BtnA.wasReleased()) {
    num--;
    Serial.println(num);
    showjpgSD();
  } else if (M5.BtnB.wasReleased()) {
    num = 0;
    Serial.println(num);
    showjpgSD();
  } else if (M5.BtnC.wasReleased()) {
    num++;
    Serial.println(num);
    showjpgSD();
  }
}

void showjpgSD() {
  if (num >= numList || num < 0) {
    num = 0;
  }
  //液晶に画像を表示します
  M5.Lcd.clear();
  int x = 0;
  int y = 0;
  int width = 0;
  int height = 0;
  int offset_x = 0;
  int offset_y = 0;
  jpeg_div_t scale = JPEG_DIV_NONE;
  M5.Lcd.drawJpgFile(SD, nameList[num],
                     x, y, width, height,
                     offset_x, offset_y,
                     scale);
}
